/**********************************************************************************
CH395 TCP/IP Эӿ
DHCPʾ,3socketֱʹ
UDP,
TCP Client,
TCP Server,
Ƭյݺ󣬰λȡϴ

ҪPC·ch395         ͬһ
**********************************************************************************/
/* ͷļ*/

#include "debug.h"
#include "string.h"
#include "../PUB/CH395INC.H"
#include "CH395.H"
/**********************************************************************************/
/*
CH395_OP_INTERFACE_MODEΪ1-5
1Ӳ߲ӷʽ
2ģⲢӷʽ
3: ӲSPIӷʽOK
4: ģSPIʽ
5: Ӳ첽ӷʽOK
*/
#define   CH395_OP_INTERFACE_MODE             3
#if   (CH395_OP_INTERFACE_MODE == 1)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_HW.C"                                           
#elif (CH395_OP_INTERFACE_MODE == 2)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_SW.C"                                            
#elif (CH395_OP_INTERFACE_MODE == 3)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_HW.H"
#elif (CH395_OP_INTERFACE_MODE == 4)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_SW.C"
#elif (CH395_OP_INTERFACE_MODE == 5)                                 /* SEL = 1, TX = 1*/
#include "../PUB/CH395UART.H"
#else
#error "Please Select Correct Communication Interface "
#endif

/**********************************************************************************/
/* ļ */
#include "../PUB/CH395CMD.H"

#define CMD_SET_HOSTNAME                      0X85                    /*  */
//ݣ1ֽڳ + 
//ֽ32ֽ

#define     CH395_DEBUG              1
#define DEF_KEEP_LIVE_IDLE                           (15*1000)     /* ʱ */
#define DEF_KEEP_LIVE_PERIOD                         (20*1000)     /* Ϊ15룬һKEEPLIVEݰ */
#define DEF_KEEP_LIVE_CNT                             200
#define CH395_DHCP                   1

/* ñ */
u8  MyBuffer[4][100];                                              /* ݻ ,ݻȿɸݵƬԴʵ,ͨѶٶ*/
struct _SOCK_INF  SockInf[4];                                      /* SocketϢ */
struct _CH395_SYS  CH395Inf;                                       /* CH395Ϣ */

/* CH395ض */
const u8 CH395IPAddr[4] = {192,168,22,10};                          /* CH395IPַ */
const u8 CH395GWIPAddr[4] = {192,168,22,1};                         /* CH395 */
const u8 CH395IPMask[4] = {255,255,255,0};                         /* CH395 */

/* socket ض,Ϊʾsocket0-2Դ˿ںĿĶ˿,socket3 */
/* ΪIP RAWҪIP ЭֶεЭ */
const u8  Socket0DesIP[4] = {192,168,1,66};     /*395UDP-Clģʽ */   /* Socket 0ĿIPַ */
const u16 Socket0DesPort = 2000;                                   /* Socket 0ĿĶ˿ */
const u16 Socket0SourPort = 5000;                                  /* Socket 0Դ˿ */
UINT8  flag  = 0;                                                  /*DHCPɹ־*/
/**********************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ룬ͣ
* Input          : iError   
* Output         : None
* Return         : None
**********************************************************************************/
void mStopIfError(u8 iError)
{
    if (iError == CMD_ERR_SUCCESS) return;                        /* ɹ */
#if CH395_DEBUG
    printf("Error: %02X\n", (u16)iError);                         /* ʾ */
#endif
    while ( 1 ) 
    {
        Delay_Ms(200);
        Delay_Ms(200);
    }
}

/**********************************************************************************
* Function Name  : InitCH395InfParam
* Description    : ʼCH395Inf
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitCH395InfParam(void)
{
    memset(&CH395Inf,0,sizeof(CH395Inf));                            /* CH395Infȫ*/
    memcpy(CH395Inf.IPAddr,CH395IPAddr,sizeof(CH395IPAddr));         /* IPַдCH395Inf */
    memcpy(CH395Inf.GWIPAddr,CH395GWIPAddr,sizeof(CH395GWIPAddr));   /* IPַдCH395Inf */
    memcpy(CH395Inf.MASKAddr,CH395IPMask,sizeof(CH395IPMask));       /* дCH395Inf */
}

/**********************************************************************************
* Function Name  : InitSocketParam
* Description    : ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitSocketParam(void)
{
    memset(&SockInf[0],0,sizeof(SockInf[0]));                        /* SockInf[0]ȫ*/
    memcpy(SockInf[0].IPAddr,Socket0DesIP,sizeof(Socket0DesIP));     /* ĿIPַд */
    SockInf[0].DesPort = Socket0DesPort;                             /* ĿĶ˿ */
    SockInf[0].SourPort = Socket0SourPort;                           /* Դ˿ */
    SockInf[0].ProtoType = PROTO_TYPE_UDP;                           /* UDPģʽ */                       /* TCPͻģʽ */
}

/**********************************************************************************
* Function Name  : CH395SocketInitOpen
* Description    : CH395 socket ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInitOpen(void)
{
    u8 i;                                                           /* Ƿɹ */
    /* socket 0ΪUDPģʽ */
    CH395SetSocketDesIP(0,SockInf[0].IPAddr);                        /* socket 0ĿIPַ */
    CH395SetSocketProtType(0,PROTO_TYPE_UDP);                        /* socket 0Э */
    CH395SetSocketDesPort(0,SockInf[0].DesPort);                     /* socket 0ĿĶ˿ */
    CH395SetSocketSourPort(0,SockInf[0].SourPort);                   /* socket 0Դ˿ */
    i = CH395OpenSocket(0);                                          /* socket 0 */
    mStopIfError(i);
}

/*********************************************************************************
* Function Name  : keeplive_set
* Description    : ʱ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void keeplive_set(void)
{
    CH395KeepLiveCNT(DEF_KEEP_LIVE_CNT);
    CH395KeepLiveIDLE(DEF_KEEP_LIVE_IDLE);
    CH395KeepLiveINTVL(DEF_KEEP_LIVE_PERIOD);
}

/**********************************************************************************
* Function Name  : CH395SocketInterrupt
* Description    : CH395 socket ж,ȫжб
* Input          : sockindex  Socket
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInterrupt(u8 sockindex)
{
    u8  sock_int_socket;
    u8  i;
    u16 len;
    u16 tmp;
    u8  buf[10];

    sock_int_socket = CH395GetSocketInt(sockindex);                  /* ȡsocket ж״̬ */
    if(sock_int_socket & SINT_STAT_SENBUF_FREE)                      /* ͻУԼдҪ͵ */
    {

    }
    if(sock_int_socket & SINT_STAT_SEND_OK)                          /* ж */
    {
    }
    if(sock_int_socket & SINT_STAT_RECV)                             /* ж */
    {
        len = CH395GetRecvLength(sockindex);                         /* ȡǰݳ */
#if CH395_DEBUG
        printf("receive len = %d\n"	,len);
#endif
        if(len == 0)return;
        if(len > 100)len = 100;                                      /* ͻΪ2048 */
        CH395GetRecvData(sockindex,len,MyBuffer[sockindex]);         /* ȡ */
        for(tmp =0; tmp < len; tmp++)                                /* ݰλȡ */
        {
            MyBuffer[sockindex][tmp] = ~MyBuffer[sockindex][tmp];
        }
        CH395SendData(sockindex,MyBuffer[sockindex],len);
   }
   if(sock_int_socket & SINT_STAT_CONNECT)                           /* жϣTCPģʽЧ*/
   {
#if CH395_DEBUG
       printf("Tcp Connect\n");
#endif

       CH395SetKeepLive(sockindex,1);                                /*KEEPALIVEʱ*/
//       CH395SetTTLNum(sockindex,40);                                 /*TTLͨ·ɸ*/

       if(SockInf[sockindex].TcpMode == TCP_SERVER_MODE)             /* socket ΪģʽûԻȡԶ˵IPͶ˿*/
       {
           CH395CMDGetRemoteIPP(sockindex,buf);
           tmp = (u16)(buf[5]<<8) + buf[4];
#if CH395_DEBUG
	       printf("IP address = %d.%d.%d.%d\n",(u16)buf[0],(u16)buf[1],(u16)buf[2],(u16)buf[3]);
	       printf("Port = %d\n",tmp);    
#endif
       }
   }
   /*
   **ϿжϺͳʱжʱCH395ĬڲرգûҪԼرոSocketóɲرSocketҪ
   **SOCK_CTRL_FLAG_SOCKET_CLOSE־λĬΪ0ñ־Ϊ1CH395ڲSocketйرմûжϺͳʱжʱ
   **CH395CloseSocketSocketйرգرSocketһֱΪӵ״̬ʵѾϿͲȥˡ
   */
   if(sock_int_socket & SINT_STAT_DISCONNECT)                        /* ϿжϣTCPģʽЧ */
   {
   }
   if(sock_int_socket & SINT_STAT_TIM_OUT)                           /* ʱжϣTCPģʽЧ */
   {
       if(SockInf[sockindex].TcpMode == TCP_CLIENT_MODE)
       {
           Delay_Ms(200);                                            /* ʱ200MSٴԣûбҪƵ */
           i = CH395OpenSocket(sockindex);
           mStopIfError(i);
           CH395TCPConnect(sockindex);                               /* ʼ */
           mStopIfError(i);
       }
    }
}

/********************************************************************************
* Function Name  : CH395GlobalInterrupt
* Description    : CH395ȫжϺ
* Input          : None
* Output         : None
* Return         : None
*********************************************************************************/
void CH395GlobalInterrupt(void)
{
    u16 init_status;
    u16 i;
    u8  buf[20];

    init_status = CH395CMDGetGlobIntStatus_ALL();
//    printf("int_sta:%d\r\n",init_status);
    if(init_status & GINT_STAT_UNREACH)                              /* ɴжϣȡɴϢ */
    {
        CH395CMDGetUnreachIPPT(buf);           
    }
    if(init_status & GINT_STAT_IP_CONFLI)                            /* IPͻжϣ޸CH395 IPʼCH395*/
    {
    }
    if(init_status & GINT_STAT_PHY_CHANGE)                           /* PHYıж*/
    {
#if CH395_DEBUG
        printf("Init status : GINT_STAT_PHY_CHANGE\n");
#endif
	}
if(init_status & GINT_STAT_DHCP)                                     /* DHCPж */
    {
    printf("DHCP!\r\n");
#if   CH395_DHCP
    i = CH395GetDHCPStatus();                                        /* DHCP״̬ */
#endif
    if(i == 0)
    {
      flag = 1;
      CH395GetIPInf(buf);
#if CH395_DEBUG
      printf("IP:%02d.%02d.%02d.%02d\n",(UINT16)buf[0],(UINT16)buf[1],(UINT16)buf[2],(UINT16)buf[3]);
      //IPַ
      printf("GWIP:%02d.%02d.%02d.%02d\n",(UINT16)buf[4],(UINT16)buf[5],(UINT16)buf[6],(UINT16)buf[7]);
      //
      printf("Mask:%02d.%02d.%02d.%02d\n",(UINT16)buf[8],(UINT16)buf[9],(UINT16)buf[10],(UINT16)buf[11]);
      //
      printf("DNS1:%02d.%02d.%02d.%02d\n",(UINT16)buf[12],(UINT16)buf[13],(UINT16)buf[14],(UINT16)buf[15]);
      //1
      printf("DNS2:%02d.%02d.%02d.%02d\n",(UINT16)buf[16],(UINT16)buf[17],(UINT16)buf[18],(UINT16)buf[19]);
      //2
#endif
      }
    }
    if(init_status & GINT_STAT_SOCK0)
    {
        CH395SocketInterrupt(0);                                     /* socket 0ж*/
    }
    if(init_status & GINT_STAT_SOCK1)                               
    {
        CH395SocketInterrupt(1);                                     /* socket 1ж*/
    }
    if(init_status & GINT_STAT_SOCK2)                                
    {
        CH395SocketInterrupt(2);                                     /* socket 2ж*/
    }
    if(init_status & GINT_STAT_SOCK3)                                
    {
        CH395SocketInterrupt(3);                                     /* socket 3ж*/
    }
    if(init_status & GINT_STAT_SOCK4)
    {
        CH395SocketInterrupt(4);                                     /* socket 4ж*/
    }
    if(init_status & GINT_STAT_SOCK5)                                
    {
        CH395SocketInterrupt(5);                                     /* socket 5ж*/
    }
    if(init_status & GINT_STAT_SOCK6)                                
    {
        CH395SocketInterrupt(6);                                     /* socket 6ж*/
    }
    if(init_status & GINT_STAT_SOCK7)                                
    {
        CH395SocketInterrupt(7);                                     /* socket 7ж*/
    }
}

/**********************************************************************************
* Function Name  : CH395Init
* Description    : CH395IP,GWIP,MACȲʼ
* Input          : None
* Output         : None
* Return         : ִн
**********************************************************************************/
u8  CH395Init(void)
{
    u8 i;
    
    i = CH395CMDCheckExist(0x65);   
    if(i != 0x9a)return CH395_ERR_UNKNOW;                            /* ޷ͨ0XFA */                                                         /* 0XFAһΪӲ߶дʱ򲻶 */
#if !CH395_DHCP                                                      /* DHCPԲIPغ */
    CH395CMDSetIPAddr(CH395Inf.IPAddr);                              /* CH395IPַ */
    CH395CMDSetGWIPAddr(CH395Inf.GWIPAddr);                          /* صַ */
    CH395CMDSetMASKAddr(CH395Inf.MASKAddr);                          /* 룬ĬΪ255.255.255.0*/
#endif
    Delay_Ms(10);
    i = CH395CMDInitCH395();                                         /* ʼCH395оƬ */
    return i;
}

/**********************************************************************************
* Function Name  : main
* Description    : main
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
int main(void)
{
    u8 i;
    Delay_Init();
    USART_Printf_Init(115200);
#if CH395_DEBUG
    printf("CH395EVT Test Demo\n");
#endif
    CH395_PORT_INIT();                                               /* ʼƬ */
    CH395CMDReset();                                                 /* CH395оƬλ */
    Delay_Ms(1000);                                                  /* Ҫʱ2000msҪֿдȻЧ */
    Delay_Ms(1000);
    printf("ʼ\n");
    i = CH395CMDGetVer();                                            /* ȡоƬԼ̼汾 */
    printf("GetVe:%02x \n",i);
    InitCH395InfParam();                                             /* ʼCH395ر */
    i = CH395Init();                                                 /* ʼCH395оƬ */
    mStopIfError(i);
    keeplive_set();                                                  /* ʱ */
    while(1)
    {                                                                /* ȴ̫ӳɹ*/
       if(CH395CMDGetPHYStatus() == PHY_DISCONN)                     /* ѯCH395Ƿ */
       {
           Delay_Ms(200);                                            /* δȴ200MSٴβѯ */
       }
       else
       {
#if CH395_DEBUG
           printf("CH395 Connect Ethernet\n");                       /* CH395оƬӵ̫ʱж */
#endif
           break;
       }
    }
#if CH395_DHCP
#if CH395_DEBUG
    printf("Start DHCP\n");
#endif
    i = CH395DHCPEnable(1);                                          /* 1DHCP */
    printf("DHCPEnable:%02x \n",i);
#endif
//    Delay_Ms(100);
    while(1)
    {
        if(GPIO_ReadInputDataBit(GPIOA,GPIO_Pin_0)==RESET)
        {
            CH395GlobalInterrupt();
        }
        if(flag)
        {
            flag = 0;                                                /* DHCPɹ־0 */
            InitSocketParam();                                       /* ʼsocketдIPء */
            CH395SocketInitOpen();                                   /* ȵDHCPɹٳʼsocket */
        }
    }
}
